
function [d_dt] = Differential_Calculus_Extended(t, z)

    %% Initialize the variables.
    
    lambda = 0.25;
    R = 585;
    R_prime = 1100;
    C_E = 250;
    C_L = 320;
    beta = 0.2;
    R_G1 = 40;
    R_G2 = 160;
    C_G1 = 85;
    C_G2 = 25;
    F = 10;
    
    x = z(1);
    y = z(2);

    %% Calculate the anticipated returns.
    
    W_L1 = y * ((1 - lambda) * (R_prime - C_E - C_L) + beta * C_L) + (1 - y) * (1 - lambda) * (R_prime - C_E - C_L);
    W_L2 = y * ((1 - lambda) * R - F) + (1 - y) * (1 - lambda) * R;
    W_L_avg = x * W_L1 + (1 - x) * W_L2;
    
    W_G1 = x * (lambda * (R_prime - C_E - C_L) + C_L + R_G1 + R_G2 - C_G1 - C_G2) + (1 - x) * (lambda * R - C_G2 + F);
    W_G2 = x * (lambda * (R_prime - C_E - C_L) + C_L + R_G1) + (1 - x) * lambda * R;
    W_G_avg = y * W_G1 + (1 - y) * W_G2;
    
    %% Calculate the partial derivatives.
    
%     dx_dt = x * (1 - x) * ((1 - lambda) * (R_prime - C_E - C_L - R) + y * beta * C_L);
%     dy_dt = y * (1 - y) * (x * (R_G2 - C_G1) - C_G2);

    dx_dt = x * (W_L1 - W_L_avg);
    dy_dt = y * (W_G1 - W_G_avg);
    
    d_dt = [dx_dt; dy_dt];

end